---
title: XRSession.inputSources
slug: Web/API/XRSession/inputSources
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Property
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XRSession
  - inputSources
---
<p>{{securecontext_header}}{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The <em>read-only</em> <strong><code>inputSources</code></strong> property of the {{DOMxRef("XRSession")}} interface returns an {{domxref("XRInputSourceArray")}} object which lists all controllers and input devices which are expressly associated with the XR device and are currently available.</span> These controllers may include handheld controllers, XR-equipped gloves, optically tracked hands, and gaze-based input methods. Keyboards, gamepads, and mice are <em>not</em> considered WebXR input sources.</p>

<div class="notecard note">
<p><strong>Note:</strong> Traditional gamepad controllers are supported using the <a href="/en-US/docs/Web/API/Gamepad_API">Gamepad API</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>inputSources</em> = <em>xrSession</em>.inputSources;</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("XRInputSourceArray")}} object listing all of the currently-connected input controllers which are linked specifically to the XR device currently in use. The returned object is <strong>live</strong>; as devices are connected to and removed from the user's system, the list's contents update to reflect the changes.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can add a handler for the <code>XRSession</code> event {{domxref("XRSession.inputsourceschange_event", "inputsourceschange")}} to be advised when the contents of the session's connected devices list changes. You can then either get the value of <code>inputSources</code> to examine the list, or you can refer to a reference to the list that you've previously saved.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-inputsources","XRSession.inputSources")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.inputSources")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("XRInputSource")}}</li>
 <li>{{DOMxRef("XRSession.oninputsourceschange")}}</li>
 <li><a href="/en-US/docs/Web/API/Gamepad_API">Gamepad API</a></li>
</ul>
